<template>

  
  <div class="myshare">
  <Dialog/>
  <Alert/>
    <v-btn small text @click="createPost" class="blue--text">
      <v-icon>mdi-rename-box</v-icon>  Create Post
    </v-btn>
  <table border="0">
    <tr v-for="post in postingans" :key="post.id" :post="post">
      <v-list>
        <v-list-item>
        <v-list-item-avatar>
          <v-img :src="'https://dummyimage.com/16:9x780'"></v-img>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title><small><b>@{{user.name}}</b> || Shared at {{ post.created_at }}</small></v-list-item-title>
        </v-list-item-content>
        
        </v-list-item>
      </v-list>
      <b> {{post.caption}} </b><br>
      <v-img width="200" :src="post.gambar ? `${apiDomain}/gambar/${post.gambar}` : 'https://picsum.photos/200/300'"></v-img>
      <small>{{ post.tulisan }}</small><br>
      <small>{{ post.qoute }}</small><br>
          
          <v-btn small text @click="editpost(post.id)" class="orange--text">
          <v-icon>mdi-circle-edit-outline</v-icon> Edit Post
          </v-btn>
          
           <v-btn small text @click="deletepost(post.id)" class="red--text">
          <v-icon>mdi-delete-empty-outline</v-icon> Delete Post
          </v-btn>
          <br><br>
    <hr>
    </tr>
    </table>

  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
export default {

  data : () => ({
      postingans : [],
      komentars : [],
      post : {},
      apiDomain : "http://127.0.0.1:8000",
    }),

  components: { 
    Alert : () => import ('../components/Alert.vue'),
    Dialog : () => import ('../components/Dialog.vue')
    },

  computed: {
    ...mapGetters({
      user : 'auth/user',
      token : 'auth/token'
    }),
  },

  methods : {
  editpost : function (postId){
  this.setDialogComponent({'component' : 'editpost'})
  this.setpostId(postId) 
  },
  deletepost : function (postId) {
          const config = {
              method: "delete",
              
              url: this.apiDomain+"/api/postingans/"+postId,
              headers: {
                'Authorization' : 'Bearer ' + this.token,
              },
          }

          this.axios(config)
              .then((response) => {
                  this.myShare()
                  console.log(response)
                  this.setAlert({
                    status : true,
                    color  : 'success',
                    text  : 'Postingan berhasil dihapus',
                })
              })
              .catch((error) => {
                  console.log(error)
              })
      },
    createPost(){
        this.setDialogComponent({'component' : 'createpost'})
    },
    ...mapActions({
    setDialogComponent : 'dialog/setComponent',
    setpostId : 'post/setpostId',
    setAlert  : 'alert/set',
    }),
    myShare: function () {
          const config = {
              method: "get",
              url: this.apiDomain + "/api/postingans_user",
              headers: {
                'Authorization' : 'Bearer ' + this.token,
              },
          }

          this.axios(config)
              .then((response) => {
                  this.postingans = response.data.data
                  
                  console.log(response.data.data)
              })
              .catch((error) => {
                  console.log(error)
              })
      },
  },
  created(){
      this.myShare();
    }
}
</script>